(*====================================================================
    File psstartmain.pas

    Program starter & updater.
    Main module.

    Copyright  2001-2008, PSTG
    http://www.polesoft.ru
    mailto:support@polesoft.ru

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
======================================================================
$Id: psstartmain.pas,v 1.17 2008/09/22 14:13:27 ariafan Exp $
======================================================================*)
unit psstartmain;

interface

uses
  Windows, SysUtils, SysConst, rCRT, BDE;

resourcestring
  srConstsSection = 'Constants';
  srOptionsSection = 'Options';
  srInsertSection = 'Insert';
  srUpdateSection = 'Update';
  srDeleteSection = 'Delete';

  srBootDir = 'bootdir';
  srWinDir = 'windir';
  srWinSysDir = 'winsysdir';
  srEtcDir = 'etcdir';
  srTempDir = 'tempdir';
  srPFDir = 'pfdir';
  srCFDir = 'cfdir';
  srMediaDir = 'mediadir';
  srSrcDir = 'srcdir';
  srDefault = '%default%';

  srHeaderValue = 'WinHeader';
  srPauseValue = 'Pause';
  srSelfPauseValue = 'SelfPause';
  srSettingsValue = 'Settings';
  srSourcePathValue = 'SourcePath';
  srLanguageValue = 'Language';
  srRunValue = 'Run';
  srSectionOrderValue = 'SectionOrder';
  srItemOrderValue = 'ItemOrder';

  srFlagNotCheckSize = 'not_check_size';
  srFlagNotCheckDateTime = 'not_check_datetime';
  srFlagCheckVersion = 'check_version';
  srFlagKeepNewest = 'keep_newest';
  srFlagIgnore = 'ignore_error';
  srFlagReboot = 'until_reboot';
  srFlag9xOnly = '9x_only';
  srFlagNTOnly = 'nt_only';

  srInclude = 'Include';
  srFile = 'File';
  srFileSource = 'Source';
  srFileFlags = 'Flags';
  srDir = 'Dir';
  srRegKey = 'Reg';
  srVal = 'Val';
  srValName = 'Name';
  srValType = 'Type';
  srValValue = 'Value';
  srIniFile = 'Ini';
  srIniSection = 'Section';
  srBDEAlias = 'BDEAlias';
  srBDEParams = 'Params';
  srTxtFile = 'Text';
  srString = 'Str';
  srStrPrefix = 'Prefix';
  srStrFull = 'Full';

  srInitProgName = 'Program Starter';
  srFail = ' FAILED ';
  srOK =   '  OK  ';
  srError = 'ERROR: ';
  srInitialize = '=> Initialization...';
  srProcessM   = '=> Processing %s...';
  srInsertM    = '=> Inserting';
  srUpdateM    = '=> Updating';
  srDeleteM    = '=> Deleting';
  srFilesM     = '   files:';
  srDirsM      = '   directories:';
  srRegKeysM   = '   registry keys:';
  srIniFilesM  = '   ini-files:';
  srBDEInit    = '   BDE initialization...';
  srBDESave    = '=> Saving BDE configuration...';
  srBDEAliasesM= '   BDE aliases:';
  srTxtFilesM  = '   text files:';
  srItemM      = '    -> %s...';
  srValueM     = '       value "%s"';
  srRunM       = '=> Loading %s...';
  srStartRepeat= '=> Repeating of Program Starter loading...';

  srParamNotFound = 'Inifile name is needed as parameter.';
  srFileNotFound = 'New version of file %s not found.';
  srFileUntilReboot = 'Can''t update or delete file %s now. An action will done at reboot the operating system.';
  srBDENotFound = 'BDE is not installed or corrupted.';
  srFileNotOpened = 'Can''t open or create file %s. Error %d.';
  srNotSupported = 'Capability not supported.';
  srSupportMessage = 'Possible, this file is opened now.'#13+
                     'If it is wrong, contact to your technical support service.';
  srPressAnyKey = 'Press any key to continue...';

const
  srSODefault  = 'IUD';
  srIOIDefault = 'DFRIBT';
  srIOUDefault = 'FRIB';
  srIODDefault = 'FDRIB';

implementation

const
  WinReg  = 'SOFTWARE\Microsoft\Windows\CurrentVersion';
  WineReg = 'Software\Wine';

type
  TConst = record
    name, value: string;
  end;

var
  inifn, setfn, exestartfn, exestartfnlng, realpath, path, exefn, comp,
  s, {$IFNDEF DEBUG}s2,{$ENDIF} Display, Display2: string;
  consts: array of TConst;
  b: Boolean = True;
  newstarter: Boolean = False;
  use_wine: Boolean = False;
  p, p1, p2: PChar;
  incl, Err: Integer;
  pause: Integer = 0;
  hk: HKEY;
  selfpause: Integer = 500;
  CanIgnore: Boolean = False;
  CanReboot: Boolean = False;
  flBDE: Boolean = False;
  StartupInfo: TStartupInfo;
  ProcessInfo: TProcessInformation;

function StrToOem(const AnsiStr: string): string;
begin
  SetLength(Result, Length(AnsiStr));
  if Length(Result) > 0 then
    CharToOemBuff(PChar(AnsiStr), PChar(Result), Length(Result));
end;

function StrToAnsi(const OEMStr: string): string;
begin
  SetLength(Result, Length(OEMStr));
  if Length(Result) > 0 then
    OemToCharBuff(PChar(OEMStr), PChar(Result), Length(Result));
end;

function WordCount(const S: string; const WordDelims: TSysCharSet): Integer;
var
  SLen, I: Cardinal;
begin
  Result := 0;
  I := 1;
  SLen := Length(S);
  while I <= SLen do begin
    while (I <= SLen) and (S[I] in WordDelims) do Inc(I);
    if I <= SLen then Inc(Result);
    while (I <= SLen) and not(S[I] in WordDelims) do Inc(I);
  end;
end;

function ExtractDelimited(N: Integer; const S: string;
  const Delims: TSysCharSet): string;
var
  CurWord: Integer;
  I, Len, SLen: Integer;
begin
  CurWord := 0;
  I := 1;
  Len := 0;
  SLen := Length(S);
  SetLength(Result, 0);
  while (I <= SLen) and (CurWord <> N) do begin
    if S[I] in Delims then Inc(CurWord)
    else begin
      if CurWord = N - 1 then begin
        Inc(Len);
        SetLength(Result, Len);
        Result[Len] := S[I];
      end;
    end;
    Inc(I);
  end;
end;

function SeparateRegKey(Source: string; var TargetRoot: HKEY; var TargetKey: string): Boolean;
var
  i: Integer;
  s: String;
begin
  TargetRoot := HKEY_CURRENT_USER;
  TargetKey := Source;
  Result := False;
  if (Length(Source) < 2) or (Source[1] = '\') then Exit;
  i := pos('\', Source);
  if i = 0 then Exit;
  s := Copy(Source, 1, i - 1);
  if (s = 'HKEY_CLASSES_ROOT') or     (s = 'HKCR') then TargetRoot := HKEY_CLASSES_ROOT
  else
  if (s = 'HKEY_CURRENT_USER') or     (s = 'HKCU') then TargetRoot := HKEY_CURRENT_USER
  else
  if (s = 'HKEY_LOCAL_MACHINE') or    (s = 'HKLM') then TargetRoot := HKEY_LOCAL_MACHINE
  else
  if (s = 'HKEY_USERS') or            (s = 'HKUS') then TargetRoot := HKEY_USERS
  else
  if (s = 'HKEY_PERFORMANCE_DATA') or (s = 'HKPD') then TargetRoot := HKEY_PERFORMANCE_DATA
  else
  if (s = 'HKEY_CURRENT_CONFIG') or   (s = 'HKCC') then TargetRoot := HKEY_CURRENT_CONFIG
  else
  if (s = 'HKEY_DYN_DATA') or         (s = 'HKDD') then TargetRoot := HKEY_DYN_DATA
  else Exit;
  TargetKey := Copy(Source, i + 1, Length(Source)-i+1);
  Result := True;
end;

procedure WriteItem(item: string);
begin
  if Display <> '' then begin
    WriteLn(StrToOem(Display));
    Display := '';
  end;
  if Display2 <> '' then begin
    WriteLn(StrToOem(Display2));
    Display2 := '';
  end;
  Write(StrToOem(item));
end;

procedure WriteOK;
var
  y: Smallint;
begin
  y := WhereY;
  if WhereX > 45 then
    if GetScreenSize.Y = y then WriteLn
    else Inc(y);
  GotoXY(45, y);

  y := TextAttr;
  Write('[');
  TextColor(LightGreen);
  try
    Write(StrToOEM(srOK));
  finally
    TextColor(y);
  end;
  WriteLn(']');
end;

procedure WriteError(Mes: string = '');
var
  y: Smallint;
begin
  y := WhereY;
  if WhereX > 45 then
    if GetScreenSize.Y = y then WriteLn
    else Inc(y);
  GotoXY(45, y);

  y := TextAttr;
  Write('[');
  TextColor(LightRed);
  try
    Write(StrToOEM(srFail));
  finally
    TextColor(y);
  end;
  WriteLn(']');

  WriteLn;
  TextColor(White);
  try
    if Mes = '' then
      WriteLn(StrToOEM(srError + SysErrorMessage(Err)))
    else
      WriteLn(StrToOEM(srError + Mes));
  finally
    TextColor(y);
  end;

  WriteLn;
  Write(StrToOEM(srPressAnyKey));
  ReadKey;
  WriteLn;
end;

function ConvertConsts(fn: string; NormFN: Boolean = False): string;
var
  p_: PChar;
  i: Integer;
begin
  Result := fn;
  i := 0;
  while (i < Length(consts)) and (Pos('%', Result) <> 0) do begin
    Result := StringReplace(Result, '%'+consts[i].name+'%', consts[i].value,
                            [rfIgnoreCase]);
    if fn <> Result then begin
      // loop start again
      fn := Result;
      i := -1;
    end;
    Inc(i);
  end;
  if Pos('%', Result) <> 0 then begin
    GetMem(p_, MAX_PATH);
    try
      ExpandEnvironmentStrings(PChar(Result), p_, MAX_PATH);
      Result := String(p_);
    finally
      FreeMem(p_);
    end;
  end;
  if NormFN and (Result[1] <> PathDelim) and (ExtractFileDrive(Result) = '') then
    Result := realpath + Result;
end;

function ConvertCodes(Source: string): string;
var
  i,j,l: Integer;
begin
  i := 0;
  l := Length(Source);
  Result := '';
  while i < l do begin
    j := Pos('\',Copy(Source,i+1,l))+i;
    if j=i then begin
      Result := Result+Copy(Source,i+1,l);
      break;
    end else begin
      Result := Result+Copy(Source,i+1,j-i-1);
      case Source[j+1] of
        '0'..'9': begin
                    i := j;
                    while (j < l) and (Source[j+1] in ['0'..'9']) do Inc(j);
                    Result := Result+Chr(StrToInt(Copy(Source,i+1,j-i)));
                    i := j;
                  end
        else begin
          Result := Result+'\';
          i := j;
        end;
      end;
    end;
  end;
end;

procedure ReadConsts(fn: String);
var
  p_: Pointer;
  ps: PChar;
  i, k, im1, im2: Integer;
  d, t: DWORD;
  sm, smp, smp2, smp3, smn: string;
begin
  GetMem(p_, 32767);
  try
    GetPrivateProfileSection(PChar(srConstsSection), p_, 32767, PChar(fn));
    k := 0;
    repeat
      ps := PChar(Integer(p_) + k);
      if Length(ps) <> 0 then begin
        i := 0;
        while (i < Length(consts)) and (CompareText(consts[i].name, Trim(ExtractDelimited(1, ps, ['=']))) <> 0) do
          Inc(i);
        if i = Length(consts) then begin
          SetLength(consts, i+1);
          consts[i].name := Trim(ExtractDelimited(1, ps, ['=']));
          consts[i].value := Trim(ExtractDelimited(2, ps, ['=']));
        end else
          consts[i].value := Trim(ExtractDelimited(2, ps, ['=']));

        //--- reg macros
        im1 := Pos('<' + srRegKey + '>', consts[i].value);
        while im1 > 0 do begin
          im2 := Pos('</' + srRegKey + '>', consts[i].value);
          // execute macros
          sm := Copy(consts[i].value, im1 + Length(srRegKey) + 2, im2 - (im1 + Length(srRegKey) + 2));
          SeparateRegKey(ConvertConsts(ExtractDelimited(1, sm, [';'])), hk, smp);
          smn := '';
          if (RegOpenKeyEx(hk, PChar(smp), 0, KEY_READ, hk) = ERROR_SUCCESS) then begin
            d := MAX_PATH;
            GetMem(p2, d);
            try
              smp2 := ConvertConsts(ExtractDelimited(2, sm, [';']));
              if RegQueryValueEx(hk, PChar(smp2), nil, @t, PByte(p2), @d) = ERROR_SUCCESS then
                smn := p2;
            finally
              FreeMem(p2);
            end;
          end;
          if Length(smn) = 0 then
            smn := ExtractDelimited(3, sm, [';']);
          // final value
          consts[i].value := Copy(consts[i].value, 1, im1 - 1) + smn +
                             Copy(consts[i].value, im2 + Length(srRegKey) + 3, Length(consts[i].value));
          im1 := Pos('<' + srRegKey + '>', consts[i].value);
        end;
        //--- ini macros
        im1 := Pos('<' + srIniFile + '>', consts[i].value);
        while im1 > 0 do begin
          im2 := Pos('</' + srIniFile + '>', consts[i].value);
          // execute macros
          sm := Copy(consts[i].value, im1 + Length(srIniFile) + 2, im2 - (im1 + Length(srIniFile) + 2));
          smn := '';
          smp := ConvertConsts(ExtractDelimited(1, sm, [';']));
          smp2 := ConvertConsts(ExtractDelimited(2, sm, [';']));
          smp3 := ConvertConsts(ExtractDelimited(3, sm, [';']));
          GetMem(p2, MAX_PATH);
          try
            if GetPrivateProfileString(PChar(smp2), PChar(smp3), '',
                               p2, MAX_PATH, PChar(smp)) <> 0 then
              smn := p2;
          finally
            FreeMem(p2);
          end;
          if Length(smn) = 0 then
            smn := ExtractDelimited(4, sm, [';']);
          // final value
          consts[i].value := Copy(consts[i].value, 1, im1 - 1) + smn +
                             Copy(consts[i].value, im2 + Length(srIniFile) + 3, Length(consts[i].value));
          im1 := Pos('<' + srIniFile + '>', consts[i].value);
        end;

        Inc(k, Length(ps) + 1);
      end;
    until (Length(ps) = 0);
  finally
    FreeMem(p_);
  end;
end;

procedure ReadOptions(fn: String);
begin
  setfn := '';
  GetPrivateProfileString(PChar(srOptionsSection), PChar(srSettingsValue), '',
                          p, MAX_PATH, PChar(fn));
  if Length(p) <> 0 then
    setfn := p;
  ReadConsts(realpath + setfn);

  GetPrivateProfileString(PChar(srOptionsSection), PChar(srHeaderValue), '',
                          p, MAX_PATH, PChar(fn));
  if Length(p) <> 0 then
    if Win32Platform = VER_PLATFORM_WIN32_NT then begin
      CharToOEM(p, p1);
      SetTitle(ConvertConsts(p1));
    end else
      SetTitle(ConvertConsts(p));

  GetPrivateProfileString(PChar(srOptionsSection), PChar(srSourcePathValue), '',
                          p, MAX_PATH, PChar(fn));
  if Length(p) = 0 then
    path := realpath
  else
    path := IncludeTrailingPathDelimiter(p);
  path := ConvertConsts(path);
  consts[8].value := ExcludeTrailingPathDelimiter(path);
  GetPrivateProfileString(PChar(srOptionsSection), PChar(srLanguageValue), '',
                          p, MAX_PATH, PChar(fn));
  if Length(p) = 0 then
    exestartfnlng := ''
  else
    exestartfnlng := ChangeFileExt(exestartfn, p);

  GetPrivateProfileString(PChar(srOptionsSection), PChar(srPauseValue), '',
                          p, MAX_PATH, PChar(realpath+inifn));
  if Length(p) <> 0 then pause := StrToIntDef(ConvertConsts(p), 0);
  GetPrivateProfileString(PChar(srOptionsSection), PChar(srSelfPauseValue), '',
                          p, MAX_PATH, PChar(fn));
  if Length(p) <> 0 then selfpause := StrToIntDef(ConvertConsts(p), 500);
end;

//--------------- Files ------------------

function GetFileSize(const FileName: string): Int64;
var
  Handle: THandle;
  FindData: TWin32FindData;
begin
  Handle := FindFirstFile(PChar(FileName), FindData);
  if Handle <> INVALID_HANDLE_VALUE then begin
    Windows.FindClose(Handle);
    if (FindData.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) = 0 then
    begin
      Int64Rec(Result).Lo := FindData.nFileSizeLow;
      Int64Rec(Result).Hi := FindData.nFileSizeHigh;
      Exit;
    end;
  end;
  Result := -1;
end;

function GetFileVersion(FileName: String): string;
var
  VersionBuffer: Pointer;
  VersionSize, Dummy: DWORD;
  PSize: Integer;
  PntVSFixedFileInfo: PVSFixedFileInfo;
begin
  Result := '';
  if FileName = '' then FileName := ParamStr(0);
  VersionSize := GetFileVersionInfoSize(PChar(FileName), Dummy);
  if VersionSize <> 0 then begin
    PSize := VersionSize;
    GetMem(VersionBuffer, PSize);
    try
      if GetFileVersionInfo(PChar(FileName), Dummy, VersionSize, VersionBuffer) and
         VerQueryValue(VersionBuffer, '\', Pointer(PntVSFixedFileInfo), VersionSize)
      then begin
        Dummy := PntVSFixedFileInfo^.dwFileVersionMS;
        Result := IntToStr(Dummy shr 16) + '.' + IntToStr(Dummy and $FFFF);
        Dummy := PntVSFixedFileInfo^.dwFileVersionLS;
        Result := Result + '.' + IntToStr(Dummy shr 16) + '.' + IntToStr(Dummy and $FFFF);
      end;
    finally
      FreeMem(VersionBuffer, PSize);
    end;
  end;
end;

function SeparateVersion(Version: String; var MS, LS: DWORD): Boolean;
var
  i, WC: Integer;
  s: String;
  V: array [1..4] of DWORD;
begin
  Result := False;
  S := '';
  MS := 0;
  LS := 0;
  WC := WordCount(Version, ['.']);
  if WC > High(V) then exit;
  for i := 1 to High(V) do begin
    if i <= WC then begin
      s := ExtractDelimited(i, Version, ['.']);
      try
        V[i] := StrToInt(s);
      except
        exit;
      end;
    end else
      V[i] := 0;
  end;
  MS := V[1] shl 16 + V[2];
  LS := V[3] shl 16 + V[4];
  Result := True;
end;

function CompareVersion(Ver1, Ver2: String): Integer;
var
  MS1, LS1, MS2, LS2: DWORD;
begin
  SeparateVersion(Ver1, MS1, LS1);
  SeparateVersion(Ver2, MS2, LS2);
  Result := Integer(MS1) - Integer(MS2);
  if (Result = 0) then
    Result := LS1 - LS2;
end;

{function ReadEnumValues(Items: TStrings; Values: TStrings; ItemName, ItemCountName: string;
                        FirstIndex: Integer = 1): Integer;
var
  i, n: Integer;
  s: string;
begin
  n := -1;
  if Length(ItemCountName) > 0 then
    n := StrToIntDef(Items.Values[ItemCountName], -1);
  Result := 0;
  i := FirstIndex;
  if n <> 0 then
    repeat
      s := Items.Values[ItemName + IntToStr(i)];
      if Length(s) > 0 then begin
        Values.Add(s);
        Inc(Result);
      end;
      Inc(i);
    until ((n = -1) and (Length(s) = 0)) or ((n <> -1) and (i-FirstIndex >= n));
end;}

function UpdateFile(fn, flags: string; Action: Char): boolean;
var
  FS: TSearchRec;
  p_: PChar;
  flNewest, flReboot: boolean;
  ver: Integer;
  tm: TDateTime;
begin
  Result := Length(fn) = 0;
  if Result then exit;
  // cut '_' (second loading Starter)
  if (Action <> 'D') and (fn[1] = '_') and
     ((AnsiCompareText(fn, exestartfn) = 0) or (AnsiCompareText(fn, exestartfnlng) = 0)) then begin
    fn := Copy(fn, 2, Length(fn));
    Sleep(selfpause);
  end;
  flReboot := False;
  fn := ConvertConsts(fn, True);
  try
    if Action <> 'D' then begin
      Err := FindFirst(path + ExtractFileName(fn), 0, FS);
      if (Err <> 0) then begin
        WriteItem(Format(srItemM, [ExtractFileName(fn)]));
        WriteError(Format(srFileNotFound, [path + ExtractFileName(fn)]));
      end;
      while Err = 0 do begin
        fn := ExtractFilePath(fn) + FS.Name;
        flNewest := Pos(srFlagKeepNewest, flags) <> 0;
        if FileExists(fn) and FileAge(fn, tm) then begin
          ver := CompareVersion(GetFileVersion(path + FS.Name), GetFileVersion(fn));
          tm := FileDateToDateTime(FS.Time) - tm;
        end else begin
          ver := 1;
          tm := 1;
        end;
        if ((Pos(srFlagNotCheckSize, flags) = 0) and (Abs(FS.Size - GetFileSize(fn)) <> 0)) or
           ((Pos(srFlagCheckVersion, flags) <> 0) and
            ((flNewest and (ver > 0)) or (not flNewest and (ver <> 0)))) or
           ((Pos(srFlagNotCheckDateTime, flags) = 0) and
            ((flNewest and (tm >= 1/24/60)) or (not flNewest and (Abs(tm) >= 1/24/60)))) then begin
          WriteItem(Format(srItemM, [FS.Name]));
          if (AnsiCompareText(ExtractFileName(fn), exestartfn) = 0) or
             (AnsiCompareText(ExtractFileName(fn), exestartfnlng) = 0) then begin
            // updating starter (first loading Starter)
            s := realpath + '_' + ExtractFileName(fn);
            Result := (not FileExists(s) or
                       SetFileAttributes(PChar(s),FILE_ATTRIBUTE_ARCHIVE)) and
                      Windows.CopyFile(PChar(path + ExtractFileName(fn)), PChar(s), False);
            // psstart.exe -> _psstart.exe  if it's not changed
            if (AnsiCompareText(ExtractFileName(fn), exestartfnlng) = 0) and
               Result and not newstarter then begin
              s := ChangeFileExt(s, ExtractFileExt(exestartfn));
              Result := (not FileExists(s) or
                        SetFileAttributes(PChar(s),FILE_ATTRIBUTE_ARCHIVE)) and
                        Windows.CopyFile(PChar(realpath + exestartfn), PChar(s), False);
            end;
            newstarter := Result;
          end else
          if (AnsiCompareText(ExtractFileName(fn), inifn) = 0) or
             (AnsiCompareText(ExtractFileName(fn), setfn) = 0) then begin
            // SourcePath validation
            GetMem(p_, MAX_PATH);
            try
              if GetPrivateProfileString(PChar(srOptionsSection), PChar(srSourcePathValue), '',
                        p_, MAX_PATH, PChar(path + ExtractFileName(inifn))) <> 0 then begin
                ReadConsts(path + ExtractFileName(inifn));
                ReadConsts(path + ExtractFileName(setfn));
                if not FileExists(ConvertConsts(String(p_)) + '\' + ExtractFileName(fn)) then begin
                  Result := False;
                  Err := 666;
                  WriteError(Format(srFileNotFound, [ConvertConsts(String(p_)) + '\' + ExtractFileName(fn)]));
                  exit;
                end;
                Result := (not FileExists(s) or
                           SetFileAttributes(PChar(s),FILE_ATTRIBUTE_ARCHIVE)) and
                          Windows.CopyFile(PChar(path + ExtractFileName(fn)), PChar(fn), False);
              end;
            finally
              FreeMem(p_);
            end;
          end else begin
            if Action = 'U' then begin
              Result := (not FileExists(fn) or
                         SetFileAttributes(PChar(fn),FILE_ATTRIBUTE_ARCHIVE)) and
                        Windows.CopyFile(PChar(path + FS.Name), PChar(fn), False);
              if not Result then
                if Pos(srFlagReboot, flags) <> 0 then begin
                  // movifile until reboot
                  flReboot := Windows.CopyFile(PChar(path + FS.Name),
                       PChar(ExtractFilePath(fn) + '_' + ExtractFileName(fn)), False);
                  if flReboot then begin
                    if Win32Platform = VER_PLATFORM_WIN32_NT then begin
                      flReboot := MoveFileEx(PChar(fn), nil, MOVEFILE_DELAY_UNTIL_REBOOT);
                      if flReboot then
                        flReboot := MoveFileEx(PChar(ExtractFilePath(fn) + '_' + ExtractFileName(fn)), PChar(fn), MOVEFILE_DELAY_UNTIL_REBOOT);
                    end else begin
                      flReboot := Integer(WritePrivateProfileString('Rename', 'NUL', PChar(fn),
                        PChar(IncludeTrailingPathDelimiter(consts[0].value) + 'wininit.ini'))) <> 0;
                      if flReboot then
                        flReboot := Integer(WritePrivateProfileString('Rename', PChar(fn), PChar(ExtractFilePath(fn) + '_' + ExtractFileName(fn)),
                          PChar(IncludeTrailingPathDelimiter(consts[0].value) + 'wininit.ini'))) <> 0;
                    end;
                  end;
                end;
            end else
              Result := FileExists(fn) or Windows.CopyFile(PChar(path + FS.Name), PChar(fn), False);
          end;
          if not Result then begin
            if flReboot then begin
              WriteError(Format(srFileUntilReboot, [fn]));
            end else begin
              Err := GetLastError;
              WriteError;
            end;
          end else
            WriteOK;
        end else begin
          // psstart.LNG -> _psstart.LNG   if it's not changed
          if (AnsiCompareText(ExtractFileName(fn), exestartfnlng) = 0) and
             newstarter then begin
            s := realpath + '_' + ExtractFileName(fn);
            Result := (not FileExists(s) or
                      SetFileAttributes(PChar(s),FILE_ATTRIBUTE_ARCHIVE)) and
                      Windows.CopyFile(PChar(realpath + exestartfnlng), PChar(s), False);
          end else
            Result := True;
        end;
        if Err = 0 then Err := FindNext(FS);
      end;
    end else begin
      Err := FindFirst(fn, faAnyfile-faDirectory, FS);
      if Err <> 0 then Result := True;
      while Err = 0 do begin
        // deleting file
        WriteItem(Format(srItemM, [FS.Name]));
        if SetFileAttributes(PChar(ExtractFilePath(fn)+FS.Name),FILE_ATTRIBUTE_ARCHIVE) and
           Windows.DeleteFile(PChar(ExtractFilePath(fn)+FS.Name)) then begin
          WriteOK;
          Result := True;
        end else begin
          if Pos(srFlagReboot, flags) <> 0 then
            if Win32Platform = VER_PLATFORM_WIN32_NT then
              flReboot := MoveFileEx(PChar(ExtractFilePath(fn)+FS.Name), nil, MOVEFILE_DELAY_UNTIL_REBOOT)
            else
              flReboot := Integer(WritePrivateProfileString('Rename', 'NUL', PChar(ExtractFilePath(fn)+FS.Name),
                PChar(IncludeTrailingPathDelimiter(consts[0].value) + 'wininit.ini'))) <> 0;
          if flReboot then begin
            WriteError(Format(srFileUntilReboot, [ExtractFilePath(fn)+FS.Name]));
          end else begin
            Err := GetLastError;
            WriteError;
          end;
          flReboot := False;
        end;
        if Err = 0 then Err := FindNext(FS);
      end;
    end;
  finally
    FindClose(FS);
  end;
end;

//------------- Directories ------------------

procedure UpdateDir(Dir: string; Action: Char);
begin
  Dir := ConvertConsts(Dir, True);
  if (Action <> 'D') = DirectoryExists(Dir) then exit;
  WriteItem(Format(srItemM, [Dir]));
  if Action <> 'U' then begin
    if ((Action = 'D') and RemoveDirectory(PChar(Dir))) or
       ((Action <> 'D') and ForceDirectories(Dir)) then WriteOK
    else begin
      Err := GetLastError;
      WriteError;
      b := False;
    end;
  end else begin
    WriteError(srNotSupported);
    b := False;
  end;
end;

//-------------- Ini files -------------------

procedure UpdateIniValue(fn, Section, Name, Value: string; Action: Char);
var
  pntr: Pointer;
begin
  Err := -1;
  Section := ConvertConsts(Section);
  Name := ConvertConsts(Name);
  Value := ConvertConsts(ConvertCodes(Value));
  if Name = '' then pntr := nil else pntr := PChar(Name);
  if GetPrivateProfileString(PChar(Section), pntr, '',
                             p2, MAX_PATH, PChar(fn)) <> 0 then begin
    if Action = 'D' then begin
      Write(StrToOem(Format(srValueM, [Name])));
      Err := Integer(WritePrivateProfileString(PChar(Section), pntr, nil, PChar(fn)));
    end else if (Action = 'U') and (String(p2) <> Value) then begin
      Write(StrToOem(Format(srValueM, [Name])));
      Err := Integer(WritePrivateProfileString(PChar(Section), pntr, PChar(Value), PChar(fn)));
    end else
  end else
    if (Action <> 'D') and (Length(Value) > 0) then begin            
      Write(StrToOem(Format(srValueM, [Name])));
      Err := Integer(WritePrivateProfileString(PChar(Section), pntr, PChar(Value), PChar(fn)));
    end;
  if Err <> -1 then
    if Err = 0 then begin             
      Err := GetLastError;
      b := False;
      WriteError;
    end else
      WriteOK;
end;

//-------------- BDE Aliases -------------------

function BDECheck(E: DBIResult): Boolean;
begin
  Result := (E = DBIERR_NONE);
  if Result then exit;
  if DbiGetErrorString(E, p) = DBIERR_NONE then
    WriteError(p)
  else
    WriteError(srBDENotFound);
  b := False;
end;

procedure UpdateAlias(alias, Params: string; Action: Char);
var
  i1: Integer;
  TmpCursor: hDbiCur;
  Db: DBDesc;
  rslt: DbiResult;
  flExists: Boolean;
begin
  alias := ConvertConsts(alias);
  s := StrToOEM(alias);
  // search existed alias with same name
  flExists := False;
  BDECheck(DbiOpenDatabaseList(TmpCursor));
  try
    repeat
      rslt:= DbiGetNextRecord(TmpCursor, dbiNOLOCK, @Db, nil);
      if (rslt <> DBIERR_EOF) then begin
        flExists := String(Db.szName) = s;
        if flExists then break;
      end;
    until (rslt <> DBIERR_NONE);
  finally
    BDECheck(DbiCloseCursor(TmpCursor));
  end;
  if ((Action <> 'I') and flExists) or
     ((Action <> 'D') and not flExists) then
    WriteItem(Format(srItemM, [alias]));

  if (Action <> 'I') and flExists then begin
    BDECheck(DbiDeleteAlias(nil, PChar(s)));
    if b and (Action = 'D') then WriteOK;
    flExists := False; // for U option
  end;
  if (Action <> 'D') and not flExists then begin
    Params := ConvertConsts(ConvertCodes(Params));
    i1 := Pos(';', Params);
    CharToOEM(PChar(Copy(Params, i1+1, Length(Params))), p1);
    BDECheck(DbiAddAlias(nil, PChar(s), PChar(Copy(Params,1,i1-1)), p1, True));
    if b then WriteOK;
  end;
end;

//------------- Text files ------------------

procedure UpdateTxt(var f: Text; Prefix, Full: string; Action: Char);
begin
  Prefix := ConvertConsts(ConvertCodes(Prefix));
  if (Action = 'I') then begin
    Full := ConvertConsts(ConvertCodes(Full));
    while not EOF(f) do begin
      ReadLn(f, s);
      if s = '' then Continue;
      if Pos(AnsiUpperCase(Prefix), AnsiUpperCase(Trim(s))) = 1 then exit;
    end;
    WriteItem(Format(srValueM, [Prefix]));
    Append(f);
    if (s <> '') and (Copy(s, Length(s), 1) <> #13) then s := sLineBreak;
    Write(f, s + Full);
    Flush(f);
    WriteOK;
  end else begin
    WriteItem(Format(srValueM, [Prefix]));
    WriteError(srNotSupported);
    b := False;
  end;
end;

//-------------- Main loops -------------------

procedure UpdateItems(ifn: string);
var
  SectionOrder, ItemOrder, key, key2: string;
  i, i2, j, k, k2, ior: Integer;
  keyWrite: Boolean;
  h: HKEY;
  f: Text;

  //------------- Registry keys ------------------

  function UpdateRegKey(var Key: HKEY; Path: string; Action: Char): Boolean;
  var
    d: DWORD;
    rk: HKEY;
  begin
    Result := True;
    if (Key <> 0) and (Action = 'W') then begin
      if keyWrite then exit;
      // reopen for write
      RegCloseKey(Key);
      d := KEY_READ + KEY_WRITE;
    end else
      d := KEY_READ;
    Path := ConvertConsts(Path);
    if Length(Path) <> 0 then begin
      if (Action <> 'D') and (Action <> 'W') then
        WriteItem(Format(srItemM, [Path]));
      SeparateRegKey(Path, Key, Path);
    end;
    if Action = 'D' then
      Err := RegDeleteKey(Key, PChar(Path))
    else begin
      Err := RegOpenKeyEx(Key, PChar(Path), 0, d, rk);
      if (Err <> ERROR_SUCCESS) and (Action <> 'O') then
        Err := RegCreateKeyEx(Key, PChar(Path), 0,
                              nil, REG_OPTION_NON_VOLATILE, d, nil, Key, @d)
      else Key := rk;
      if Err = ERROR_SUCCESS then
        keyWrite := d = KEY_READ + KEY_WRITE;
    end;
    Result := Err = ERROR_SUCCESS;
    if not Result then WriteError;
  end;

  procedure UpdateRegValue(Key: HKEY; Name, Value: string; ValType, Action: Char);
  var
    d, t, t2, sz, val: DWORD;
    pntr, pdata: Pointer;
    bu: Boolean;
    ii: Integer;
  begin
    t := REG_BINARY;
    sz := 0;
    pntr := nil;
    if Action <> 'D' then begin
      Value := ConvertConsts(ConvertCodes(Value));
      case ValType of
        'S', 'M':
             begin
               if (ValType = 'S') then t := REG_SZ
               else t := REG_MULTI_SZ;
               sz := Length(Value)+1;
               pntr := PChar(Value);
             end;
        'I': begin
               t := REG_DWORD;
               sz := 4;
               val := StrToIntDef(Value, 0);
               pntr := @val;
             end;
      else
        sz := Length(Value);
        pntr := Addr(Value[1]);
      end;
    end;
    d := MAX_PATH;
    Err := -1;
    Name := ConvertConsts(Name);
    if AnsiCompareText(Name, srDefault) = 0 then Name := '';
    GetMem(pdata, MAX_PATH);
    try
      if RegQueryValueEx(Key, PChar(Name), nil, @t2, PByte(pdata), @d) = ERROR_SUCCESS then begin
        if Action = 'D' then begin
          Write(StrToOem(Format(srValueM, [Name])));
          if UpdateRegKey(Key, p, 'W') then
            Err := RegDeleteValue(Key, PChar(Name));
        end else if (Action = 'U') then begin
          bu := (t2 <> t) or
                ((t in [REG_SZ,REG_MULTI_SZ]) and (Length(Value) <> Integer(d) - 1)) or
                ((t <> REG_DWORD) and not (t in [REG_SZ,REG_MULTI_SZ]) and (Length(Value) <> Integer(d)));
          if not bu then
            if t2 = REG_DWORD then
              try
                bu := DWORD(pdata^) <> val;
              except
                bu := True;
              end
            else
              for ii := 1 to Length(Value) do begin
                bu := (Value[ii] <> String(PChar(pdata))[ii]);
                if bu then break;
              end;
          if bu then begin
            Write(StrToOem(Format(srValueM, [Name])));
            if UpdateRegKey(Key, p, 'W') then
              Err := RegSetValueEx(Key, PChar(Name), 0, t, pntr, sz);
          end;
        end
      end else
        if Action <> 'D' then begin
          Write(StrToOem(Format(srValueM, [Name])));
          if UpdateRegKey(Key, p, 'W') then
            Err := RegSetValueEx(Key, PChar(Name), 0, t, pntr, sz);
        end;
    finally
      FreeMem(pdata);
    end;
    if Err <> -1 then begin
      b := b and (Err = ERROR_SUCCESS);
      if Err = ERROR_SUCCESS then WriteOK else WriteError;
    end;
  end;

begin
  SectionOrder := srSODefault;
  GetPrivateProfileString(PChar(srOptionsSection), PChar(srSectionOrderValue), '',
                          p, MAX_PATH, PChar(ifn));
  if Length(p) <> 0 then
    SectionOrder := UpperCase(p);

  try
    for i := 1 to Length(SectionOrder) do begin
      case SectionOrder[i] of
        'I': begin
               key := srInsertSection;
               Display := srInsertM;
             end;
        'U': begin
               key := srUpdateSection;
               Display := srUpdateM;
             end;
        'D': begin
               key := srDeleteSection;
               Display := srDeleteM;
             end;
      else key := '';
      end;
      // loop for personal computer setup
      i2 := 1;
      repeat
        if i2 = 2 then begin
          key := key + '.' + comp;
          Display := Display + ' [ '+comp+' ]';
        end;

        case SectionOrder[i] of
          'I': ItemOrder := srIOIDefault;
          'U': ItemOrder := srIOUDefault;
          'D': ItemOrder := srIODDefault;
        else ItemOrder := '';
        end;
        GetPrivateProfileString(PChar(key), PChar(srItemOrderValue), '',
                                p1, MAX_PATH, PChar(ifn));
        if Length(p1) <> 0 then
          ItemOrder := UpperCase(p1);

        for j := 1 to Length(ItemOrder) do begin
          case ItemOrder[j] of
            'D': key2 := srDir;
            'F': key2 := srFile;
            'R': key2 := srRegKey;
            'I': key2 := srIniFile;
            'B': key2 := srBDEAlias;
            'T': key2 := srTxtFile;
          else key2 := '';
          end;
          k := 1;
          repeat
            GetPrivateProfileString(PChar(key), PChar(key2+IntToStr(k)), '',
                                    p, MAX_PATH, PChar(ifn));
            if Length(p) <> 0 then begin
              Sleep(pause);
              if k = 1 then
                case ItemOrder[j] of
                  'D': Display2 := srDirsM;
                  'F': Display2 := srFilesM;
                  'R': Display2 := srRegKeysM;
                  'I': Display2 := srIniFilesM;
                  'B': Display2 := srBDEAliasesM;
                  'T': Display2 := srTxtFilesM;
                end;
              case ItemOrder[j] of
                'D': UpdateDir(p, SectionOrder[i]);
                'F': begin
                       GetPrivateProfileString(PChar(key), PChar(srFile + IntToStr(k) + srFileFlags), '',
                                               p1, MAX_PATH, PChar(ifn));
                       s := ConvertConsts(p1);
                       if ((Pos(srFlag9xOnly, s) = 0) or (Win32Platform <> VER_PLATFORM_WIN32_NT)) and
                          ((Pos(srFlagNTOnly, s) = 0) or (Win32Platform = VER_PLATFORM_WIN32_NT)) then
                         b := b and UpdateFile(p, s, SectionOrder[i]);
                     end;
                'R': begin
                       k2 := 1;
                       h := 0;
                       if SectionOrder[i] = 'D' then UpdateRegKey(h, p, 'O')
                       else b := b and UpdateRegKey(h, p, SectionOrder[i]);
                       if h <> 0 then begin
                         GetMem(p2, MAX_PATH);
                         keyWrite := False;
                         try
                           repeat
                             GetPrivateProfileString(PChar(key), PChar(key2+IntToStr(k)+srVal+IntToStr(k2)+srValName), '',
                                                     p1, MAX_PATH, PChar(ifn));
                             if Length(p1) <> 0 then begin
                               if SectionOrder[i] <> 'D' then begin
                                 GetPrivateProfileString(PChar(key), PChar(key2+IntToStr(k)+srVal+IntToStr(k2)+srValType), '',
                                                         p2, MAX_PATH, PChar(ifn));
                                 if Length(p2) <> 0 then s := UpperCase(String(p2)[1]) else s := 'S';
                                 GetPrivateProfileString(PChar(key), PChar(key2+IntToStr(k)+srVal+IntToStr(k2)+srValValue), '',
                                                         p2, MAX_PATH, PChar(ifn));
                               end;
                               if k2 = 1 then WriteLn;
                               UpdateRegValue(h, p1, p2, s[1], SectionOrder[i]);
                               Inc(k2);
                             end;
                           until (Length(p1) = 0) or not b;
                         finally
                           FreeMem(p2);
                         end;
                         if k2 = 1 then begin
                           // delete entire key
                           if SectionOrder[i] = 'D' then
                             b := b and UpdateRegKey(h, p, 'D');
                           if b then WriteLn;
                         end;
                         if keyWrite then RegFlushKey(h);
                         RegCloseKey(h);
                         h := 0;
                       end;
                     end;
                'I': begin
                       WriteItem(Format(srItemM, [ExtractFileName(ConvertConsts(p))]));
                       k2 := 1;
                       GetMem(p2, MAX_PATH);
                       try
                         repeat
                           s := p1;
                           GetPrivateProfileString(PChar(key), PChar(key2+IntToStr(k)+srVal+IntToStr(k2)+srIniSection), '',
                                                   p1, MAX_PATH, PChar(ifn));
                           // if next section is not specified then assign previous section
                           if (Length(p1) = 0) and (k2 > 1) then
                             StrPCopy(p1, s);
                           if Length(p1) <> 0 then begin
                             GetPrivateProfileString(PChar(key), PChar(key2+IntToStr(k)+srVal+IntToStr(k2)+srValName), '',
                                                     p2, MAX_PATH, PChar(ifn));
                             s := p2;
                             if Length(p2) <> 0 then begin
                               if SectionOrder[i] <> 'D' then
                                 GetPrivateProfileString(PChar(key), PChar(key2+IntToStr(k)+srVal+IntToStr(k2)+srValValue), '',
                                                         p2, MAX_PATH, PChar(ifn));
                               if k2 = 1 then WriteLn;
                               UpdateIniValue(ConvertConsts(p, True), p1, s, p2, SectionOrder[i]);
                               StrPCopy(p2, '*');  // any symbol
                               Inc(k2);
                             end;
                           end;
                         until (Length(p1) = 0) or (Length(p2) = 0) or not b;
                       finally
                         FreeMem(p2);
                       end;
                       if (k2 = 1) and b then WriteLn;
                     end;
                'B': begin
                       if not flBDE then begin
                         Write(StrToOEM(srBDEInit));
                         if BDECheck(DbiInit(nil)) then WriteOK;
                         flBDE := b;
                       end;
                       GetPrivateProfileString(PChar(key), PChar(srBDEAlias+IntToStr(k)+srBDEParams), '',
                                               p1, MAX_PATH, PChar(ifn));
                       UpdateAlias(p, p1, SectionOrder[i]);
                     end;
                'T': begin;
                       k2 := 1;
                       s := ConvertConsts(p, True);
                       WriteItem(Format(srItemM, [ExtractFileName(s)]));
                       AssignFile(f, s);
                       SetLineBreakStyle(f, tlbsLF);
                       {$I-}
                       if FileExists(s) then Reset(f) else Rewrite(f);
                       ior := IOResult;
                       {$I+}
                       if ior = 0 then begin
                         GetMem(p2, MAX_PATH);
                         try
                           repeat
                             GetPrivateProfileString(PChar(key), PChar(key2+IntToStr(k)+srString+IntToStr(k2)+srStrPrefix), '',
                                                     p1, MAX_PATH, PChar(ifn));
                             if Length(p1) <> 0 then begin
                               GetPrivateProfileString(PChar(key), PChar(key2+IntToStr(k)+srString+IntToStr(k2)+srStrFull), '',
                                                       p2, MAX_PATH, PChar(ifn));
                               if k2 = 1 then WriteLn;
                               UpdateTxt(f, p1, p2, SectionOrder[i]);
                               Inc(k2);
                             end;
                           until (Length(p1) = 0) or not b;
                         finally
                           FreeMem(p2);
                           CloseFile(f);
                         end;
                         if k2 = 1 then WriteLn;
                       end else begin
                         WriteError(Format(srFileNotOpened, [s, ior]));
                         b := False;
                       end;
                     end;
              end;
            end;
            Inc(k);
// for debug
//if not b then begin writeln(key+'..'+key2+' '+string(p)); readkey; end;
          until (Length(p) = 0) or not b;
          if not b then exit;
        end;
        Inc(i2);
      until i2 > 2;
    end;
  finally
    if h <> 0 then RegCloseKey(h);
  end;
end;

//------------ IncludeXXX processing ----------------

procedure DoIncludes(fn: String);
var
  i: Integer;
  sinc: string;
begin
  i := 1;
  repeat
    GetPrivateProfileString(PChar(srOptionsSection), PChar(srInclude + IntToStr(i)), '',
                            p, MAX_PATH, PChar(fn));
    if Length(p) <> 0 then begin
      sinc := ExtractFileName(ConvertConsts(p));
      Write(StrToOEM(Format(srProcessM, [sinc])));
      Display := srUpdateM;
{$IFNDEF DEBUG}
      WriteLn;
      if UpdateFile(sinc, '', 'U') then begin
{$ELSE}
      if FileExists(realpath + sinc) then begin
        WriteLn;
{$ENDIF}
        ReadConsts(realpath + sinc);
        DoIncludes(realpath + sinc);
        UpdateItems(realpath + sinc);
{$IFNDEF DEBUG}
      end else b := False;
{$ELSE}
      end else begin
        WriteError(Format(sFileNotFound, [sinc]));
        b := False;
      end;
{$ENDIF}
      Inc(i);
    end else break
  until not b;
end;

initialization
  SetTitle(StrToOEM(srInitProgName));
  WriteLn('Program Starter & Updater 1.4');
  WriteLn('Copyright (c) 2001-2008, PSTG    http://www.polesoft.ru');
  Write(StrToOEM(srInitialize));
  GetStartupInfo(StartupInfo);
  realpath := ExtractFilePath(ParamStr(0));
  exestartfn := ExtractFileName(ParamStr(0));
  inifn := ParamStr(1);
  if inifn = '' then begin
    WriteError(srParamNotFound);
    Halt(1);
  end;
  GetMem(p, MAX_PATH);
  GetMem(p1, MAX_PATH);
  try
  try

    incl := MAX_PATH;
    GetComputerName(p, DWORD(incl));
    comp := p;

    use_wine := RegOpenKeyEx(HKEY_CURRENT_USER, PChar(WineReg), 0, KEY_READ, hk) = ERROR_SUCCESS;

    // set default constants
    SetLength(consts, 9);
    GetWindowsDirectory(p, MAX_PATH);
    consts[0].name := srWinDir;
    consts[0].value := p;
    GetSystemDirectory(p, MAX_PATH);
    consts[1].name := srWinSysDir;
    consts[1].value := p;
    consts[2].name := srEtcDir;
    if Win32Platform = VER_PLATFORM_WIN32_NT then
      consts[2].value := consts[1].value + '\drivers\etc'
    else
      consts[2].value := consts[0].value;
    GetTempPath(MAX_PATH, p);
    consts[3].name := srTempDir;
    consts[3].value := p;
    incl := MAX_PATH;
    if RegOpenKeyEx(HKEY_LOCAL_MACHINE, PChar(WinReg), 0, KEY_READ, hk) <> ERROR_SUCCESS then
      RaiseLastOSError;
    try
      if RegQueryValueEx(hk, 'ProgramFilesDir', nil, nil, PByte(p), @incl) <> ERROR_SUCCESS then
        RaiseLastOSError;
      consts[4].name := srPFDir;
      consts[4].value := p;
      incl := MAX_PATH;
      if RegQueryValueEx(hk, 'CommonFilesDir', nil, nil, PByte(p), @incl) <> ERROR_SUCCESS then
        RaiseLastOSError;
      consts[5].name := srCFDir;
      consts[5].value := p;
      incl := MAX_PATH;
      if (RegQueryValueEx(hk, 'MediaPath', nil, nil, nil, nil) = ERROR_SUCCESS) then begin
        if (RegQueryValueEx(hk, 'MediaPath', nil, nil, PByte(p), @incl) <> ERROR_SUCCESS) then
          RaiseLastOSError;
        consts[6].name := srMediaDir;
        consts[6].value := p;
      end;

      if RegOpenKeyEx(hk, 'Setup', 0, KEY_READ, hk) <> ERROR_SUCCESS then
        RaiseLastOSError;
      incl := MAX_PATH;
      if RegQueryValueEx(hk, 'BootDir', nil, nil, PByte(p), @incl) <> ERROR_SUCCESS then
        RaiseLastOSError;
      consts[7].name := srBootDir;
      consts[7].value := p;
    finally
      RegCloseKey(hk);
    end;
    consts[8].name := srSrcDir;

    WriteLn;
    try
{$IFDEF DEBUG}
      if True then
{$ELSE}
      // self-updating of starter & inifile
      path := '';
      s2 := '.';
      repeat
        if s2 <> path then begin
          ReadConsts(realpath + inifn);
          ReadOptions(realpath + inifn);
          s2 := path;
          b := UpdateFile(exestartfn, '', 'U') and UpdateFile(exestartfnlng, '', 'U') and
               UpdateFile(setfn, '', 'U') and UpdateFile(inifn, '', 'U');
        end;
      until not b or (s2 = path);
      if b then
{$ENDIF}
      begin
        if not newstarter then begin
          ReadConsts(realpath + inifn);
          // read new Options
          ReadOptions(realpath + inifn);
          GetPrivateProfileString(PChar(srOptionsSection), PChar(srRunValue), '',
                                  p, MAX_PATH, PChar(realpath+inifn));
          exefn := ConvertConsts(p);

          DoIncludes(realpath + inifn);
          if b then begin
            WriteLn(StrToOEM(Format(srProcessM, [inifn])));
            UpdateItems(realpath+inifn);
          end;
        end;

      end;
    finally
      if flBDE then begin
        Write(StrToOEM(srBDESave));
        if BDECheck(DbiCfgSave(nil, nil, Bool(-1))) then WriteOK;
        DbiExit;
      end;
    end;
    if b and newstarter then begin
      Write(StrToOEM(srStartRepeat));
      b := CreateProcess(NIL, PChar(realpath + '_' + exestartfn + ' ' + inifn),
                         NIL, NIL, False, NORMAL_PRIORITY_CLASS, NIL,
                         NIL, StartupInfo, ProcessInfo);
      if not b then RaiseLastOSError;
    end else
    if b and not newstarter and not use_wine and (exefn <> '') then begin
      Write(StrToOEM(Format(srRunM, [exefn])));
      b := CreateProcess(NIL, PChar(realpath + exefn),
                         NIL, NIL, False, NORMAL_PRIORITY_CLASS, NIL,
                         NIL, StartupInfo, ProcessInfo);
      if not b then RaiseLastOSError;
    end;
  except
    on E: Exception do begin
      WriteError(E.Message);
      Halt(2);
    end;
  end;
  finally
    FreeMem(p);
    FreeMem(p1);
  end;
  if not b then Halt(2);
end.
